---
title: Bulk import
description: The bulk import service lets you import large numbers of entries from a CSV file into the IDM repository. Importing user entries is a very common use case, but you can import any managed object type.
component: pingoneaic
page_id: pingoneaic:idm-rest-api:endpoints/rest-bulk-import
canonical_url: https://docs.pingidentity.com/pingoneaic/idm-rest-api/endpoints/rest-bulk-import.html
---

# Bulk import

The bulk import service lets you import large numbers of entries from a CSV file into the IDM repository. Importing user entries is a very common use case, but you can import any managed object type.

The following table shows the endpoints used by the bulk import service:

| URI                                                                | HTTP Operation | Description                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| ------------------------------------------------------------------ | -------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `/openidm/csv/template?resourceCollection=managed/realm-name_user` | GET            | Generates a CSV header row that you can use as a template for the import. You can safely remove generated columns for properties that are not required. Set the query parameters `_fields=header` and `_mimeType=text/csv` to download the header file.                                                                                                                                                                                          |
| `/upload/csv/resourceCollection`                                   | POST           | Uploads the file specified by the `--form` (`-F`) parameter to the specified resource collection. `?uniqueProperty=propertyName` is required. Generally, for `managed/realm-name_user` objects, the `uniqueProperty` is `userName`. You can specify multiple comma-delimited values here to identify unique records; for example, `?uniqueProperty=firstName,lastName`. [Example](../../idm-synchronization/import-data.html#query-bulk-import). |
| `/openidm/csv/metadata/?_action=cleanupList`                       | POST           | Returns the import UUIDs that have error records or temporary records. These can be cleaned up to free up database space. If you clean up error records, you will no longer be able to download a CSV of failed import records.                                                                                                                                                                                                                  |
| `/openidm/csv/metadata/importUUID?_action=cleanup`                 | POST           | Cleans up temporary import records for the specified import UUID. To also clean up error records, set the query parameter `?deleteErrorRecords=true`.                                                                                                                                                                                                                                                                                            |
| `/openidm/csv/metadata/importUUID?_action=cancel`                  | POST           | Cancels the specified in-progress import.                                                                                                                                                                                                                                                                                                                                                                                                        |
| `/openidm/csv/metadata/importUUID`                                 | DELETE         | Deletes the specified import record. This does not affect the data that was imported.                                                                                                                                                                                                                                                                                                                                                            |
| `/openidm/csv/metadata?_queryFilter`                               | GET            | Queries bulk imports.                                                                                                                                                                                                                                                                                                                                                                                                                            |
| `/openidm/csv/metadata/importUUID`                                 | GET            | Returns the specified import record.                                                                                                                                                                                                                                                                                                                                                                                                             |
| `/export/csvImportFailures/importUUID`                             | GET            | Downloads a CSV file of failed import records. Returns 404 if there were no failures for the specified import UUID.                                                                                                                                                                                                                                                                                                                              |
